#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int MOD = 998'244'353;

struct mint {
    int x;

    void normalize() {
        if (x < 0) {
            x += MOD;
        }
        if (x >= MOD) {
            x -= MOD;
        }
    }

    mint() : x(0) {}

    mint(int a) {
        x = a % MOD;
        normalize();
    }

    mint(ll a) {
        x = a % MOD;
        normalize();
    }
};

mint operator+(const mint &a, const mint &b) {
    return mint(a.x + b.x);
}

mint operator-(const mint &a, const mint &b) {
    return mint(a.x - b.x);
}

mint operator*(const mint &a, const mint &b) {
    return mint(a.x * ll(b.x));
}

mint operator/(const mint& a, mint b) {
    mint c = 1;
    int p = MOD - 2;
    while (p) {
        if (p & 1) {
            c = c * b;
        }
        b = b * b;
        p /= 2;
    }
    return a * c;
}

//using mint = double;

const int N = 10;

mint dp[N][N];
mint fact[N];
mint invFact[N];

mint binPow(mint a, ll p) {
    mint b = 1;
    while (p) {
        if (p & 1) {
            b = b * a;
        }
        a = a * a;
        p /= 2;
    }
    return b;
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);

    fact[0] = fact[1] = 1;
    for (int i = 2; i < N; i++) {
        fact[i] = fact[i - 1] * i;
    }
    invFact[N - 1] = 1 / fact[N - 1];
    for (int i = N - 2; i >= 0; i--) {
        invFact[i] = invFact[i + 1] * (i + 1);
    }

    int n, k, s;
    cin >> n >> k >> s;
    vector<int> a(k);
    int badPos = -1;
    for (int i = 0; i < k; i++) {
        cin >> a[i];
        if (a[i] == s) {
            badPos = i;
        }
    }
    rotate(a.begin(), a.begin() + badPos, a.end());
    vector<int> segs;
    auto calcDist = [n](int i, int j) {
        if (i < j) {
            return j - i;
        } else {
            return n - i + j;
        }
    };
    segs.push_back(calcDist(a[k - 1], a[0]));
    for (int i = 0; i + 1 < k; i++) {
        segs.push_back(calcDist(a[i], a[i + 1]));
    }
    reverse(segs.begin() + 1, segs.end());
    dp[0][0] = 1;
//    mint invN = binPow(n, MOD - 2);
    mint invN = 1 / mint(n);
    for (int i = 1; i < segs.size(); i++) {
        for (int j = 0; j <= i - 1; j++) {
            for (int cur = 0; cur <= j + 1; cur++) {
                dp[i][j + 1 - cur] = dp[i][j + 1 - cur] + dp[i - 1][j] * binPow(segs[i] * invN, cur) * invFact[cur];
            }
        }
    }

    vector<mint> probAlive(k + 1);
    vector<mint> probStop(k + 1);
    mint res = 0;
    for (int i = 1; i <= k; i++) {
        probAlive[i] = dp[k - 1][(k - 1) - i] * fact[i];
        probStop[i] = 1 - probAlive[i];
        for (int j = 0; j < i; j++) {
            probStop[i] = probStop[i] - probStop[j];
        }
//        res = res + i * probStop[i];
        res = res + i * (probAlive[i - 1] - probAlive[i]);
    }

    cout << (res + 1).x;
//    cout << endl;
//    cout << res;
    return 0;
}
