#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define pii pair<int,int>
#define pll pair<long long, long long>
#define pld pair<long double, long double>

using namespace std;
using ll = long long;

ll n;
vector<pair<pll, pll> > segms;

bool are_collinear(pair<pll, pll> const& o1, pair<pll, pll> const& o2) {
    return (o1.fi.fi - o1.se.fi) * (o2.fi.se - o2.se.se) == (o2.fi.fi - o2.se.fi) * (o1.fi.se - o1.se.se);
}

bool is_inter(pair<pll, pll> const& o, pll const& x) {
    if (min(o.fi.fi, o.se.fi) <= x.fi && max(o.fi.fi, o.se.fi) >= x.fi &&
        min(o.fi.se, o.se.se) <= x.se && max(o.fi.se, o.se.se) >= x.se) {
        return x == o.fi || are_collinear(o, mp(o.fi, x));
    } else {
        return 0;
    }
}

bool cmp(pair<pll, int> const& a, pair<pll, int> const& b) {
    if (a.fi < b.fi) return 0;
    if (a.fi > b.fi) return 1;
    int i = a.se, j = b.se;
    if (are_collinear(segms[i], segms[j])) return 0;
    if (segms[i].fi.fi - segms[i].se.fi < 0 && segms[j].fi.fi - segms[j].se.fi >= 0) return 0;
    if (segms[i].fi.fi - segms[i].se.fi >= 0 && segms[j].fi.fi - segms[j].se.fi < 0) return 1;
    return (segms[i].fi.fi - segms[i].se.fi) * (segms[j].fi.se - segms[j].se.se) <
            (segms[j].fi.fi - segms[j].se.fi) * (segms[i].fi.se - segms[i].se.se);
}

ll get_ans(vector<pair<pll, int>> const& seg0) {
    ll am = 0;
    ll an = 0;
    ll lst = 0;
    for (size_t j = 0; j < seg0.size(); j++) {
        lst++;
        if (j == 0 || seg0[j].fi != seg0[j - 1].fi) {
            am = 0;
        }
        an += am;
        if (j + 1 < seg0.size() &&
            (seg0[j].fi != seg0[j + 1].fi ||
             seg0[j].fi == seg0[j + 1].fi &&
             !are_collinear(segms[seg0[j].se], segms[seg0[j + 1].se]))) {
            am += lst;
            lst = 0;
        }
    }
    return an;
}

bool is_right(pll& c, pll& a, pll& b) {
    return (a.fi - c.fi) * (b.se - c.se) - (b.fi - c.fi) * (a.se - c.se) < 0;
}

void solve() {
    segms.clear();
    cin >> n;
    for (size_t i = 0; i < n; i++) {
        ll x, y, u, v;
        cin >> x >> y >> u >> v;
        segms.pb(mp(mp(x, y), mp(u, v)));
    }
    //cout << are_collinear(segms[6], segms[7]) << "\n";
    ll ans = 0;
    for (size_t i = 0; i < n; i++) {
        vector<pair<pll, int>> seg0, seg1;
        for (size_t j = 0; j < n; j++) {
            if (!are_collinear(segms[i], segms[j])) {
                if (is_inter(segms[i], segms[j].fi) && !(segms[i].fi == segms[j].fi || segms[i].se == segms[j].fi)) {
                    if (is_right(segms[j].fi, segms[i].fi, segms[j].se)) {
                        seg0.push_back(mp(segms[j].fi, j));
                    } else {
                        seg1.push_back(mp(segms[j].fi, j));
                    }
                } else if (is_inter(segms[i], segms[j].se) && !(segms[i].fi == segms[j].se || segms[i].se == segms[j].se)) {
                    if (is_right(segms[j].se, segms[i].fi, segms[j].fi)) {
                        seg0.push_back(mp(segms[j].se, j));
                    } else {
                        seg1.push_back(mp(segms[j].se, j));
                    }
                }
            }
        }
        sort(seg0.begin(), seg0.end(), cmp);
        sort(seg1.begin(), seg1.end(), cmp);
        /*cout << i << ": \n seg0:\n";
        for (size_t j = 0; j < seg0.size(); j++) {
            cout << seg0[j].fi.fi << " " << seg0[j].fi.se << " - "  << seg0[j].se << "\n";
        }
        cout << "    " << get_ans(seg0) << "\n";
        cout << " seg1:\n";
        for (size_t j = 0; j < seg1.size(); j++) {
            cout << seg1[j].fi.fi << " " << seg1[j].fi.se << " - "  << seg1[j].se << "\n";
        }
        cout << "    " << get_ans(seg1) << "\n";*/
        ans += get_ans(seg0) + get_ans(seg1);
    }
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
