#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define pii pair<int,int>
#define pll pair<long long, long long>
#define pld pair<long double, long double>

using namespace std;
using ll = long long;

const int BUBEN = 1e6 + 500;

struct SegTree {
    vector<int> tSum, tSumAdd, tMax, tAdd, tMin;
    int d;

    SegTree() {
        d = 1;
        while (d < BUBEN) {
            d *= 2;
        }
        tSum.resize(2 * d);
        tSumAdd.resize(2 * d);
        tMax.resize(2 * d);
        tMin.resize(2 * d);
        tAdd.resize(2 * d);
    }

    void push(int v) {
        tSum[v] += tSumAdd[v];
        tMax[v] += tAdd[v];
        tMin[v] += tAdd[v];
        if (v < d) {
            tAdd[v * 2] += tAdd[v];
            tAdd[v * 2 + 1] += tAdd[v];
            tSumAdd[v * 2] += tSumAdd[v] / 2;
            tSumAdd[v * 2 + 1] += tSumAdd[v] / 2;
        }
        tAdd[v] = 0;
        tSumAdd[v] = 0;
    }

    void add(int l, int r, int x, int tl, int tr, int v) {
        push(v);
        if (l <= tl && tr <= r) {
            tAdd[v] += x;
            tSumAdd[v] += x * (tr - tl + 1);
            push(v);
            return;
        }
        if (l > tr || r < tl) {
            return;
        }
        int tm = (tl + tr) / 2;
        add(l, r, x, tl, tm, v * 2);
        add(l, r, x, tm + 1, tr, v * 2 + 1);
        tSum[v] = tSum[v * 2] + tSum[v * 2 + 1];
        tMax[v] = max(tMax[v * 2], tMax[v * 2 + 1]);
        tMin[v] = min(tMin[v * 2], tMin[v * 2 + 1]);
    }

    void add(int l, int r, int x) {
        add(l, r, x, 0, d - 1, 1);
    }

    int getRightLess(int l, int x, int tl, int tr, int v) {
        push(v);
        if (tMin[v] >= x) {
            return -1;
        }
        if (tr < l) {
            return -1;
        }
        if (tl == tr) {
            if (tSum[v] < x) {
                return v - d;
            } else {
                return -1;
            }
        }
        int tm = (tl + tr) / 2;
        int ans = getRightLess(l, x, tl, tm, v * 2);
        if (ans == -1) {
            return getRightLess(l, x, tm + 1, tr, v * 2 + 1);
        } else {
            return ans;
        }
    }

    int getRightLess(int l, int x) {
        return getRightLess(l, x, 0, d - 1, 1);
    }

    int getRightBig(int l, int x, int tl, int tr, int v) {
        push(v);
        if (tMax[v] <= x) {
            return -1;
        }
        if (tr < l) {
            return -1;
        }
        if (tl == tr) {
            if (tSum[v] > x) {
                return v - d;
            } else {
                return -1;
            }
        }
        int tm = (tl + tr) / 2;
        int ans = getRightBig(l, x, tl, tm, v);
        if (ans == -1) {
            return getRightBig(l, x, tm + 1, tr, v);
        } else {
            return ans;
        }
    }

    int getRightBig(int l, int x) {
        return getRightBig(l, x, 0, d - 1, 1);
    }

    int get(int x, int tl, int tr, int v) {
        push(v);
        if (tl == tr) {
            return tSum[v];
        }
        int tm = (tl + tr) / 2;
        if (x <= tm) {
            return get(x, tl, tm, v * 2);
        } else {
            return get(x, tm + 1, tr, v * 2 + 1);
        }
    }

    int get(int x) {
        return get(x, 0, d - 1, 1);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);

    int n;
    cin >> n;
    SegTree cntNumbers, cntPrefMinNumbers;

    auto add = [&](int x) {
        cntNumbers.add(x, x, 1);
        if (x == 0 || cntPrefMinNumbers.get(x - 1) >= cntPrefMinNumbers.get(x) + 1) {
            int ed = cntNumbers.getRightLess(x, cntPrefMinNumbers.get(x) + 1);
            cntPrefMinNumbers.add(x, ed - 1, 1);
        }
    };

    auto rem = [&](int x) {
        cntNumbers.add(x, x, -1);
        if (cntPrefMinNumbers.get(x) <= cntNumbers.get(x)) {
            return;
        }
        int ed = cntNumbers.getRightLess(x, cntPrefMinNumbers.get(x));
        cntPrefMinNumbers.add(x, ed - 1, -1);
    };

    vector<int> cnt(BUBEN);
    for (int i = 0; i < n; i++) {
        cin >> cnt[i];
        cntNumbers.add(i, i, cnt[i]);
        cnt[i] = min(cnt[i], i ? cnt[i - 1] : (int)1e9);
        cntPrefMinNumbers.add(i, i, cnt[i]);
    }
    cntPrefMinNumbers.push(1);
    cout << cntPrefMinNumbers.tSum[1] << "\n";
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int t, x;
        cin >> t >> x;
        if (t == 1) {
            add(x);
        } else {
            rem(x);
        }
        cntPrefMinNumbers.push(1);
        cout << cntPrefMinNumbers.tSum[1] << "\n";
    }

    return 0;
}
