#include<bits/stdc++.h>
#define _ << ' ' <<
#define f first
#define s second

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

#define cerr if (0) cerr

const int MAXN = 2e5 + 10, MAXM = MAXN * 4, INF = 1e9;

int treeMin[MAXM];
ll treeSum[MAXM];
int addSum[MAXM], addMin[MAXM];

int pref[MAXN], prefMin[MAXN];

void build(int v, int l, int r) {
    addSum[v] = -1;
    if (l == r - 1) {
        treeMin[v] = pref[l];
        treeSum[v] = prefMin[l];
        return;
    }
    int m = (l + r) / 2;
    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m, r);
    treeMin[v] = min(treeMin[v * 2 + 1], treeMin[v * 2 + 2]);
    treeSum[v] = treeSum[v * 2 + 1] + treeSum[v * 2 + 2];
}

void updSum(int v, int l, int r, int val) {
    treeSum[v] = 1ll * val * (r - l);
    addSum[v] = val;
}

void pushSum(int v, int l, int r) {
    if (addSum[v] == -1) return;
    int m = (l + r) / 2;
    updSum(v * 2 + 1, l, m, addSum[v]);
    updSum(v * 2 + 2, m, r, addSum[v]);
    addSum[v] = -1;
}

void updateSum(int v, int l, int r, int ql, int qr, int val) {
    if (ql <= l && r <= qr) {
        updSum(v, l, r, val);
        return;
    }
    if (ql >= r || l >= qr) return;
    int m = (l + r) / 2;
    pushSum(v, l, r);
    updateSum(v * 2 + 1, l, m, ql, qr, val);
    updateSum(v * 2 + 2, m, r, ql, qr, val);
    treeSum[v] = treeSum[v * 2 + 1] + treeSum[v * 2 + 2];
}
void updateMin(int v, int l, int r, int i, int val) {
    if (l == r - 1) {
        treeMin[v] += val;
        return;
    }
    int m = (l + r) / 2;
    if (i < m) updateMin(v * 2 + 1, l, m, i, val);
    else updateMin(v * 2 + 2, m, r, i, val);
    treeMin[v] = min(treeMin[v * 2 + 1], treeMin[v * 2 + 2]);
}

int getMin(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) return treeMin[v];
    if (ql >= r || l >= qr) return INF;
    int m = (l + r) / 2;
    return min(getMin(v * 2 + 1, l, m, ql, qr), getMin(v * 2 + 2, m, r, ql, qr));
}

int n;

void delElem(int x) {
    cerr << "del" _ x << endl;
    int prefMin = getMin(0, 0, n, 0, x + 1);
    updateMin(0, 0, n, x, -1);
    int val = getMin(0, 0, n, 0, x + 1);
    if (val == prefMin) {
        return;
    }
    prefMin = val;
    int l = x, r = n, mid;
    while (r - l > 1) {
        mid = (l + r) / 2;
        if (getMin(0, 0, n, 0, mid + 1) == prefMin) l = mid;
        else r = mid;
    }
    cerr << "right" _ r << endl;
    updateSum(0, 0, n, x, r, val);
}

void addElem(int x) {
    cerr << "add" _ x << endl;
    int prefMin = getMin(0, 0, n, 0, x + 1);
    updateMin(0, 0, n, x, 1);
    int val = getMin(0, 0, n, 0, x + 1);
    if (val == prefMin) {
        return;
    }
    prefMin = val;
    int l = x, r = n, mid;
    while (r - l > 1) {
        mid = (l + r) / 2;
        if (getMin(0, 0, n, 0, mid + 1) == prefMin) l = mid;
        else r = mid;
    }
    cerr << "right" _ r << endl;
    updateSum(0, 0, n, x, r, val);
}

void solve() {
    int x, q;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> pref[i];
    }
    prefMin[0] = pref[0];
    for (int i = 1; i < n; i++) prefMin[i] = min(prefMin[i - 1], pref[i]);
    build(0, 0, n);
    cerr << "prefMin: ";
    /*for (int i = 0; i < n; i++) {
        cerr << getMin(0, 0, n, 0, i + 1) << ' ';
    }
    cerr << endl;*/
    cout << treeSum[0] << '\n';
    cin >> q;
    int type;
    while (q--) {
        cin >> type >> x;
        if (type == 1) addElem(x);
        else delElem(x);
        cerr << "prefMin: ";
        /*for (int i = 0; i < n; i++) {
            cerr << getMin(0, 0, n, 0, i + 1) << ' ';
        }
        cerr << endl;*/
        cout << treeSum[0] << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
/*
prefMin: 4 4 4 3 3 3 2 2
25
prefMin: 4 4 3 3 3 3 2 2
24
prefMin: 5 4 3 3 3 3 2 2
25
prefMin: 5 4 4 3 3 3 2 2
26
prefMin: 5 4 4 3 3 3 3 2
27
prefMin: 4 4 4 3 3 3 3 2
26
prefMin: 4 4 3 3 3 3 3 2
25
*/
