#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<map>
#include<cmath>
using namespace std;
#define int long long
const int _1e9 = 1'000'000'000;
vector<int>otrtree;
int n2 = 1;
int n;
int get(int l, int r, int ind, int lQ, int rQ) {
	if (rQ <= l || r <= lQ) {
		return _1e9;
	}
	if (lQ <= l && r <= rQ) {
		return otrtree[ind];
	}
	int m = (l + r) / 2;
	return min(get(l, m, ind * 2, lQ, rQ), get(m, r, ind * 2 + 1, lQ, rQ));
}
int getmin(int l, int r) {
	return get(1, n2 + 1, 1, l + 1, r + 1);
}
int get(int x, int val) {
	if (getmin(1, n) >= val) {
		return n;
	}
	int l = x - 1;
	int r = n;
	while (r - l > 1) {
		int m = (l + r + 1) / 2;//first <val
		if (getmin(x, m + 1) < val) {
			r = m;
		} else {
			l = m;
		}
	}
	return r;
}
void add(int l, int r, int ind, int x, int v) {
	if (l > x || r <= x) {
		return;
	}
	if (l == r - 1) {
		otrtree[ind] += v;
		return;
	}
	int m = (l + r) / 2;
	add(l, m, ind * 2, x, v);
	add(m, r, ind * 2 + 1, x, v);
	otrtree[ind] = min(otrtree[ind * 2], otrtree[ind * 2 + 1]);
}
void add(int x, int v) {
	add(1, n2 + 1, 1, x + 1, v);
}
void inittree(vector<int>& a) {
	while (n2 < a.size()) {
		n2 *= 2;
	}
	otrtree.assign(n2 * 2, 0);
	for (int i = 0; i < a.size(); ++i) {
		add(i, a[i]);
	}
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin >> n;
	vector<int>a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	inittree(a);
	int ans = 0;
	int cur = _1e9;
	for (int i = 0; i < n; ++i) {
		cur = min(cur, a[i]);
		ans += cur;
	}
	cout << ans << '\n';
	int Q;
	cin >> Q;
	for (int i = 0; i < Q; ++i) {
		int t, x;
		cin >> t >> x;
		if (t == 1) {
			add(x, 1);
			a[x] += 1;
			if (x == 0 || a[x] <= get(1, n2 + 1, 1, 1, x + 1)) {
				int nextI = get(x + 1, a[x]);
				ans += nextI - x;
			}
		} else {
			add(x, -1);
			a[x] -= 1;
			if (x == 0 || a[x] + 1 <= get(1, n2 + 1, 1, 1, x + 1)) {
				int nextI = get(x + 1, a[x] + 1);
				ans -= nextI - x;
			}
		}
		cout << ans << '\n';
	}
	return 0;
}