#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
typedef long long ll;

using namespace std;

struct Point {
    ll x, y;
};

Point operator+(Point a, Point b) {
    return Point{ .x = a.x + b.x, .y = a.y + b.y };
}

Point operator-(Point a, Point b) {
    return Point{ .x = a.x - b.x, .y = a.y - b.y };
}

ll operator*(Point a, Point b) {
    return a.x * b.x + a.y * b.y;
}

ll operator/(Point a, Point b) {
    return a.x * b.y - a.y * b.x;
}

istream& operator>>(istream& in, Point& a) {
    return in >> a.x >> a.y;
}

bool operator<(Point a, Point b) {
    if (a.x != b.x)
        return a.x < b.x;
    return a.y < b.y;
}

bool operator ==(Point a, Point b) {
    return a.x == b.x && a.y == b.y;
}

inline void solve() {
    int n; cin >> n;
    vector<Point> pts;
    vector<pair<Point, Point>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].first >> v[i].second;
        pts.push_back(v[i].first);
        pts.push_back(v[i].second);
    }

    sort(all(pts));
    pts.resize(unique(all(pts)) - pts.begin());

    for (auto p : pts)
        cerr << p.x << ' ' << p.y << '\n';

    vector <pair <int, int>> edges;
    for (int i = 0; i < n; i++) {
        edges.emplace_back(
            lower_bound(all(pts), v[i].first) - pts.begin(),
            lower_bound(all(pts), v[i].second) - pts.begin()
        );
    }

    vector<vector<int>> g(pts.size());
    for (auto& [x, y] : edges) {
        g[x].push_back(y);
        g[y].push_back(x);
    }

    long long ans = 0;
    for (int c = 0; c < pts.size(); c++) {
        cerr << "c = " << c << endl;
        vector <pair <int, int>> ab;
        int vert_count = 0;
        vector <pair<int, int>> to_left_prs, to_right_prs;
        int to_top = 0, to_bottom = 0;

        for (auto& [aa, bb] : edges) {
            if ((pts[aa] - pts[c]) * (pts[bb] - pts[c]) < 0 && (pts[aa] - pts[c]) / (pts[bb] - pts[c]) == 0) {
                if (pts[aa].x == pts[c].x) {
                    vert_count++;
                    continue;
                }
                if (pts[aa].x > pts[c].x)
                    swap(aa, bb);
                ab.emplace_back(aa, bb);
                to_left_prs.emplace_back(aa, -1);
                to_left_prs.emplace_back(aa, 1);
                to_right_prs.emplace_back(bb, -1);
                to_right_prs.emplace_back(bb, 1);
            }
        }

        sort(all(ab), [&pts, &c](pair <int, int> s1, pair <int, int> s2){
            return (pts[s1.second] - pts[c]) / (pts[s2.second] - pts[c]) > 0;
        });

        cerr << "g[c]: ";
        for (int i : g[c]) {
            cerr << i << ' ';
            if (pts[i].x < pts[c].x)
                to_left_prs.emplace_back(i, 0);
            if (pts[i].x == pts[c].x) {
                if (pts[i].y < pts[c].y)
                    to_bottom++;
                else
                    to_top++;
            }
            if (pts[i].x > pts[c].x)
                to_right_prs.emplace_back(i, 0);
        }
        cerr << '\n';

        auto comp = [&pts, &c] (pair <int, int> i, pair <int, int> j) {
            long long vpr = (pts[i.first] - pts[c]) / (pts[j.first] - pts[c]);
            if (vpr == 0)
                return i.second < j.second;
            return vpr > 0;
        };

        sort(all(to_left_prs), comp);
        sort(all(to_right_prs), comp);

        vector <int> to_left;
        vector <int> left_lb, left_ub;
        pair <int, int> lastp;
        cerr << "to left: ";
        for (auto& [i, tag] : to_left_prs) {
            cerr << "(" << i << " " << tag << ")\n";
            if (tag == 0) {
                if (to_left.empty()) {
                    to_left.push_back(1);
                    lastp = {i, 0};
                } else if (!comp(lastp, {i, 0})) {
                    to_left.back()++;
                } else {
                    to_left.push_back(1);
                    lastp = {i, 0};
                }
            }
            if (tag == -1)
                left_lb.push_back(to_left.size());
            if (tag == 1)
                left_ub.push_back(to_left.size());
        }
        cerr << "\n";

        for (int i : to_left)
            cerr << i << ' ';
        cerr << '\n';

        vector <int> to_right;
        vector <int> right_lb, right_ub;
        cerr << "tr" << '\n';
        for (auto& [i, tag] : to_right_prs) {
            cerr << "(" << i << " " << tag << ")\n";
            if (tag == 0) {
                if (to_right.empty()) {
                    to_right.push_back(1);
                    lastp = {i, 0};
                } else if (!comp(lastp, {i, 0})) {
                    to_right.back()++;
                } else {
                    to_right.push_back(1);
                    lastp = {i, 0};
                }
            }
            if (tag == -1)
                right_lb.push_back(to_right.size());
            if (tag == 1)
                right_ub.push_back(to_right.size());
        }
        
        vector <int> to_left_psum(to_left.size() + 1);
        vector <int> to_left_psum_sq(to_left.size() + 1);
        for (int i = 1; i <= to_left.size(); i++) {
            to_left_psum[i] = to_left_psum[i - 1] + to_left[i - 1];
            to_left_psum_sq[i] = to_left[i - 1] * to_left[i - 1] + to_left_psum_sq[i - 1];
        }

        vector <int> to_left_ssum(to_left.size() + 1);
        vector <int> to_left_ssum_sq(to_left.size() + 1);
        for (int i = to_left.size() - 1; i >= 0; i--) {
            to_left_ssum[i] = to_left_ssum[i + 1] + to_left[i];
            to_left_ssum_sq[i] = to_left[i] * to_left[i] + to_left_ssum_sq[i + 1];
        }

        vector <int> to_right_psum(to_right.size() + 1);
        vector <int> to_right_psum_sq(to_right.size() + 1);
        for (int i = 1; i <= to_right.size(); i++) {
            to_right_psum[i] = to_right_psum[i - 1] + to_right[i - 1];
            to_right_psum_sq[i] = to_right[i - 1] * to_right[i - 1] + to_right_psum_sq[i - 1];
        }

        vector <int> to_right_ssum(to_right.size() + 1);
        vector <int> to_right_ssum_sq(to_right.size() + 1);
        for (int i = to_right.size() - 1; i >= 0; i--) {
            to_right_ssum[i] = to_right_ssum[i + 1] + to_right[i];
            to_right_ssum_sq[i] = to_right[i] * to_right[i] + to_right_ssum_sq[i + 1];
        }
        
        ans += to_left_psum[to_left.size()] * to_left_psum[to_left.size()] - to_left_psum_sq[to_left.size()];
        ans += to_right_psum[to_right.size()] * to_right_psum[to_right.size()] - to_right_psum_sq[to_right.size()];
        
        for (int i = 0; i < ab.size(); i++) {
            long long sum = to_left_ssum[left_ub[i]] + to_bottom + to_right_psum[right_lb[i]];
            long long sum_sq = to_left_ssum_sq[left_ub[i]] + to_bottom * to_bottom + to_right_psum_sq[right_lb[i]];
            cerr << sum << ' ' << sum_sq << '\n';
            ans += sum * sum - sum_sq;
        }

        for (int i = 0; i < ab.size(); i++) {
            long long sum = to_right_ssum[right_ub[i]] + to_top + to_left_psum[left_lb[i]];
            long long sum_sq = to_right_ssum_sq[right_ub[i]] +to_top * to_top  + to_left_psum_sq[left_lb[i]];
            ans += sum * sum - sum_sq;
        }
    }

    cout << ans / 2 << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}