#include <bits/stdc++.h>
#ifdef LOCAL
#include "debug.h"
#endif
using namespace std;

#define int long long

struct Node {
    int l, r;
    int sum, min, res;
};

int n;
vector<int> a;
vector<int> b;
vector<Node> tree;

void init(int i, int index) {
    tree[i].sum = a[index] > 0;
    tree[i].min = index < n ? a[index] : -1;
    tree[i].res = index * b[index];
}

void apply(int i) {
    tree[i].sum = tree[2 * i + 1].sum + tree[2 * i + 2].sum;
    tree[i].min = min(tree[2 * i + 1].min, tree[2 * i + 2].min);
    tree[i].res = tree[2 * i + 1].res + tree[2 * i + 2].res;
}

void build(int i, int l, int r) {
    tree[i].l = l, tree[i].r = r;
    if (l + 1 == r) {
        init(i, l);
        return;
    }
    int mid = (l + r) / 2;
    build(2 * i + 1, l, mid);
    build(2 * i + 2, mid, r);
    apply(i);
}

int find_leftest(int i, int l, int r, int value) {
    if (l >= tree[i].r or r <= tree[i].l or tree[i].min >= value) {
        return LLONG_MAX;
    }
    if (tree[i].l + 1 == tree[i].r) {
        return tree[i].l;
    }
    auto left_result = find_leftest(2 * i + 1, l, r, value);
    return left_result == LLONG_MAX ?
           find_leftest(2 * i + 2, l, r, value) :
           left_result;
}

void update(int i, int index) {
    if (index < tree[i].l or index >= tree[i].r) {
        return;
    }
    if (tree[i].l == index and tree[i].r == index + 1) {
        init(i, index);
        return;
    }
    update(2 * i + 1, index);
    update(2 * i + 2, index);
    apply(i);
}

int get_min(int i, int l, int r) {
    if (l >= tree[i].r or r <= tree[i].l) {
        return LLONG_MAX;
    }
    if (l <= tree[i].l and r >= tree[i].r) {
        return tree[i].min;
    }
    return min(get_min(2 * i + 1, l, r), get_min(2 * i + 2, l, r));
}

int get_result(int i) {
    if (tree[i].l + 1 == tree[i].r) {
        return tree[i].res;
    }
    if (tree[2 * i + 1].sum == tree[2 * i + 1].r - tree[2 * i + 1].l) {
        return tree[2 * i + 1].res + get_result(2 * i + 2);
    } else {
        return get_result(2 * i + 1);
    }
}

void solve() {
    cin >> n;
    a.resize(n + 1, 0);
    b.resize(n + 1, 0);
    tree.resize(4 * n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    int pref_min = 0;
    for (int i = 0; i < n; ++i) {
        b[i] = max(pref_min - a[i], 0LL);
        pref_min = i ? min(pref_min, a[i]) : a[i];
    }

    build(0, 0, n + 1);
    cout << get_result(0) << endl;

    int q;
    cin >> q;
    while (q--) {
        /*cout << "a = ";
        for (auto &i : a) {
            cout << i << ' ';
        }
        cout << endl;
        cout << "b = ";
        for (auto & i : b) {
            cout << i << ' ';
        }
        cout << endl;*/

        int p, v;
        cin >> p >> v;
        int to_add = p == 1 ? 1 : -1;

        auto mn = get_min(0, 0, v);
        auto b_min = find_leftest(0, v + 1, n + 1, a[v]);
//        cout << "b_min = " << b_min << endl;

        a[v] += to_add;
        b[v] = v ? max(mn - a[v], 0LL) : 0;
        update(0, v);
        if (mn > a[v] - to_add) {
            b[b_min] += to_add;
            update(0, b_min);
        }

        cout << get_result(0) << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int T = 1;
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
    cin >> T;
#endif
    for (int t = 0; t < T; ++t) {
        solve();
    }
}
