#include<bits/stdc++.h>

using namespace std;

template<typename T>
istream& operator >> (istream &in, vector<T> &v){
	for(int i = 0; i < v.size(); i++)
		in >> v[i];

	return in;
}

template<typename T>
ostream& operator << (ostream &out, vector<T> &v){
	for(int i = 0; i < v.size(); i++)
		out << v[i] << " \n"[i + 1 == v.size()];

	return out;
}

template<typename T, typename U>
ostream& operator << (ostream &out, vector<pair<T, U>> &v){
	for(int i = 0; i < v.size(); i++)
		out << v[i].first << ' ' << v[i].second << '\n';

	return out;
}

template<typename T, typename U>
istream& operator >> (istream &in, pair<T, U> &p){
	in >> p.first >> p.second;
	return in;
}

template<typename T, typename U>
ostream& operator << (ostream &out, pair<T, U> &p){
	out << p.first << ' ' << p.second;
	return out;
}

#define int long long

const long long INF64 = 1e18;

struct Node{
	int add = 0, val;

	Node() {}
	Node(int x) { this->val = x; }

	Node operator + (Node b){
		Node res = *this;
		res.val = min(res.val, b.val);
		res.add = 0;
		return res;
	}
};

void push(int v, int l, int r, vector<Node> &t){
	t[v].val += t[v].add;

	if(r - l == 1){
		t[v].add = 0;
		return;
	}

	t[v << 1].add += t[v].add;
	t[v << 1 | 1].add += t[v].add;
	t[v].add = 0;
}

void Build(int v, int l, int r, vector<Node> &t, vector<int> &a){
	if(r - l == 1){
		if(l < a.size())
			t[v] = Node(a[l]);
		else
			t[v] = Node(INF64);

		return;
	}

	int mid = (l + r) >> 1;

	Build(v << 1, l, mid, t, a);
	Build(v << 1 | 1, mid, r, t, a);

	t[v] = t[v << 1] + t[v << 1 | 1];
}

void upd(int v, int l, int r, int ql, int qr, int x, vector<Node> &t){
	if(ql <= l && r <= qr){
		t[v].add += x;
		push(v, l, r, t);
		return;
	}

	push(v, l, r, t);

	if(qr <= l || r <= ql)
		return;

	int mid = (l + r) >> 1;

	upd(v << 1, l, mid, ql, qr, x, t);
	upd(v << 1 | 1, mid, r, ql, qr, x, t);

	t[v] = t[v << 1] + t[v << 1 | 1];
}

Node get(int v, int l, int r, int ql, int qr, vector<Node> &t){
	push(v, l, r, t);

	if(ql <= l && r <= qr)
		return t[v];

	if(qr <= l || r <= ql)
		return Node(INF64);

	int mid = (l + r) >> 1;

	return get(v << 1, l, mid, ql, qr, t) + get(v << 1 | 1, mid, r, ql, qr, t);
}

int sz;

int get_need_r(int ql, int qr, vector<Node> &t, int x){
	int l = ql - 1, r = qr;

	while(r - l > 1){
		int mid = (l + r) >> 1;

		if(get(1, 0, sz, ql, mid + 1, t).val > x)
			l = mid;
		else
			r = mid;
	}

	return l;
}

void Solve(){
	int n;
	cin >> n;
	vector<int> a(n + 2);
	vector<int> b(n + 2);

	for(int i = 0; i < n; i++)
		cin >> a[i];

	sz = 1; while(sz <= n + 3) sz <<= 1;

	for(int i = 1; i <= n + 1; i++){
		b[i] = max(0ll, a[i] - a[i - 1]);
		a[i] = min(a[i - 1], a[i]);
	}

	int sum = 0;

	for(int i = 1; i <= n; i++)
		sum += i * (a[i - 1] - a[i]);

	vector<Node> ta(sz << 1);
	vector<Node> tb(sz << 1);

	Build(1, 0, sz, ta, a);
	Build(1, 0, sz, tb, b);

	// int j = 0;

	// cout << get(1, 0, sz, j, j + 1, tb).val << endl;
	// cout << get(1, 0, sz, j + 1, j + 2, tb).val << endl;

	// exit(0);

	cout << sum << '\n';

	int q; cin >> q;

	while(q--){
		int type; cin >> type;
		int j; cin >> j;

		if(type == 1){ // plus
			if(j == 0){
				upd(1, 0, sz, j, j + 1, 1, ta);
				int r = get_need_r(j + 1, n + 2, tb, 0); // find max r

				// cout << "r = " << r << endl;
				// cout << get(1, 0, sz, j, j + 1, tb).val << endl;
				// cout << get(1, 0, sz, j + 1, j + 2, tb).val << endl;

				upd(1, 0, sz, j + 1, r + 1, 1, ta);
				upd(1, 0, sz, j + 1, r + 1, -1, tb);

				sum += (r + 1 - j);
			}else{
				int kek = get(1, 0, sz, j, j + 1, ta).val;
				int lol = get(1, 0, sz, j - 1, j, ta).val;

				if(kek + 1 > lol){
					upd(1, 0, sz, j, j + 1, 1, tb);
				}else{
					upd(1, 0, sz, j, j + 1, 1, ta);
					int r = get_need_r(j + 1, n + 2, tb, 0); // find max r

					upd(1, 0, sz, j + 1, r + 1, 1, ta);
					upd(1, 0, sz, j + 1, r + 1, -1, tb);

					sum += (r + 1 - j);
				}
			}
		}else{ // minus
			int kek = get(1, 0, sz, j, j + 1, tb).val;

			if(kek > 0){
				upd(1, 0, sz, j, j + 1, -1, tb);
			}else{
				upd(1, 0, sz, j, j + 1, -1, ta);
				int kek = get(1, 0, sz, j, j + 1, ta).val;

				int r = get_need_r(j + 1, n + 2, ta, kek); // find max r

				upd(1, 0, sz, j + 1, r + 1, -1, ta);
				upd(1, 0, sz, j + 1, r + 1, 1, tb);

				sum -= (r + 1 - j);
			}
		}

		cout << sum << '\n';
	}
}

signed main(){
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);

	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "r", stdin);

	int test_cnt = 1;
	// cin >> test_cnt;

	for(int i = 1; i <= test_cnt; i++){
		Solve();
	}
}