#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

#define all(a) a.begin(), a.end()
#define rsort(a) sort(a, [&](auto c, auto b){return c > b;})

using namespace std;

using ll = long long;

void solve()
{
	ll n, m; cin >> n >> m;
	vector<string> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vector<vector<ll>> upmax(n, vector<ll>(m, 0)), downmax(n, vector<ll>(m, 0));


	vector<ll> len(m, 0);

	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
		{
			if (a[i][j] == '#')
				len[j] = 0;
			else
				++len[j];

			if (i < n - 1)
				upmax[i + 1][j] = max(upmax[i][j], len[j]);
		}

	len.assign(m, 0);

	for (int i = n - 1; i >= 0; --i)
		for (int j = 0; j < m; ++j)
		{
			if (a[i][j] == '#')
				len[j] = 0;
			else
				++len[j];

			if (i > 0)
				downmax[i - 1][j] = max(downmax[i][j], len[j]);
		}


	vector<ll> cmax(m, 0);

	vector<ll> clen;

	for (int j = 0; j < m; ++j)
	{
		ll last = -1;
		for (int i = 0; i < n; ++i)
		{
			if (a[i][j] == '#')
			{
				clen.push_back(i - last - 1);
				cmax[j] = max(cmax[j], i - last - 1);
				last = i;
			}
		}

		clen.push_back(n - last - 1);
		cmax[j] = max(cmax[j], n - last - 1);
		last = n;
	}

	vector<ll> pcm(m, 0), scm(m, 0);
	pcm[0] = cmax[0];
	scm[m - 1] = cmax[m - 1];
	for (int i = 1; i < m; ++i)
		pcm[i] = max(pcm[i - 1], cmax[i]);

	for (int i = m - 2; i >= 0; --i)
		scm[i] = max(scm[i + 1], cmax[i]);


	vector<ll> rmax(n, 0);

	vector<ll> rlen;

	for (int i = 0; i < n; ++i)
	{
		ll last = -1;
		for (int j = 0; j < m; ++j)
		{
			if (a[i][j] == '#')
			{
				rlen.push_back(j - last - 1);
				rmax[i] = max(rmax[i], j - last - 1);
				last = j;
			}
		}

		rlen.push_back(m - last - 1);
		rmax[i] = max(rmax[i], m - last - 1);
		last = m;
	}

	rsort(all(clen));
	rsort(all(rlen));

	ll anscc = 0;
	if (clen.size() > 0)
		anscc += clen[0];
	if (clen.size() > 1)
		anscc += clen[1];


	ll ansrr = 0;
	if (rlen.size() > 0)
		ansrr += rlen[0];
	if (rlen.size() > 1)
		ansrr += rlen[1];

	ll ansrc = 0;
	for (int i = 0; i < n; ++i)
	{
		ll maxc = 0;
		ll last = -1;
		for (int j = 0; j < m; ++j)
		{
			if (a[i][j] == '#')
			{
				ll cans = maxc;
				if (last >= 0)
					cans = max(cans, pcm[last]);
				cans = max(cans, scm[j]);
				maxc = 0;
				ansrc = max(ansrc, cans + j - last - 1);
				last = j;
			}
			else
			{
				maxc = max({ maxc, upmax[i][j], downmax[i][j] });
			}
		}

		ll cans = maxc;
		if (last >= 0)
			cans = max(cans, pcm[last]);
		maxc = 0;
		ansrc = max(ansrc, cans + m - last - 1);
	}

	cout << max({ ansrc, anscc, ansrr }) << endl;
	
}

int main()
{
	ll t; cin >> t;

	while (t--)
		solve();

	return 0;
}