#include <bits/stdc++.h>

using namespace std;
typedef string str;

int n;
int n_;
int startColor;
vector<int> grid;
vector<int> path;
#define grid(i, j) grid[(i) + (j) * n]

struct cube_t {
    int b{-1}, l{-1}, k{-1}, f{-1}, r{-1}, t{-1};
};

void dump(const cube_t &c) {
    cout << c.b << ' ' << c.l << ' ' << c.k << ' ' << c.f << ' ' << c.r << ' ' << c.t << endl;
}

inline int fill(const int &x) {
    return x == -1 ? startColor : x;
}

void dumpFillEmpty(const cube_t &c) {
    cout << fill(c.b) << ' ' << fill(c.l) << ' '
         << fill(c.k) << ' ' << fill(c.f) << ' '
         << fill(c.r) << ' ' << fill(c.t) << '\n';
}


inline bool checkToRight(const cube_t &cube, const int &color) {
    return cube.r == color || cube.r == -1;
}

inline bool checkToDown(const cube_t &cube, const int &color) {
    return cube.f == color || cube.f == -1;
}

inline cube_t moveRight(const cube_t &cube, const int &bottomColor) {
    return (cube_t) {bottomColor, cube.b, cube.k, cube.f, cube.t, cube.l};
}

inline cube_t moveDown(const cube_t &cube, const int &bottomColor) {
    return (cube_t) {bottomColor, cube.l, cube.b, cube.t, cube.r, cube.k};
}

inline cube_t moveLeft(const cube_t &cube) {
    return (cube_t) {cube.l, cube.t, cube.k, cube.f, cube.b, cube.r};
}

inline cube_t moveUp(const cube_t &cube) {
    return (cube_t) {cube.k, cube.l, cube.t, cube.b, cube.r, cube.f};
}


inline void solve();

bool dfs(const cube_t &cube, const int &row, const int &col);

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) solve();
    return 0;
}

inline void solve() {
    cin >> n;
    n_ = n - 1;
    grid.resize(n * n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> grid(i, j);
        }
    }

    startColor = grid(0, 0);
    cube_t start{grid(0, 0), -1, -1, -1, -1, -1};

    path.clear();
    if (!dfs(start, 0, 0)) {
        cout << "NO\n";
    }
}

cube_t reCube(cube_t cube) {
    std::reverse(path.begin(), path.end());
    for (const int &item: path) {
        if (item == 1) {
            cube = moveUp(cube);
        } else {
            cube = moveLeft(cube);
        }
    }
    return cube;
}

bool dfs(const cube_t &cube, const int &row, const int &col) {
    if (row == n_ && col == n_) {
        cout << "YES" << endl;
        dumpFillEmpty(reCube(cube));
        return true;
    }
    if (row < n_ && checkToDown(cube, grid(row + 1, col))) {
        cube_t newCube = moveDown(cube, grid(row + 1, col));
        path.push_back(1); // down
        if (dfs(newCube, row + 1, col)) {
            return true;
        } else {
            path.pop_back();
        }
    }
    if (col < n_ && checkToRight(cube, grid(row, col + 1))) {
        cube_t newCube = moveRight(cube, grid(row, col + 1));
        path.push_back(0); // right
        if (dfs(newCube, row, col + 1)) {
            return true;
        } else {
            path.pop_back();
        }
    }

    return false;
}

/*
4
2
1 1
0 0
3
1 2 3
9 6 4
7 8 1
4
1 2 3 4
9 8 7 5
10 8 12 2
13 14 15 6
4
1 2 3 4
5 6 7 8
9 10 11 12
13 14 15 16
 */