/*
 * Copyright © 6highloads (Shik, Kirsanov, Ushkov)
 * 2022
 */


#include <bits/stdc++.h>
#define fastio ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)

using namespace std;

using ll = int64_t;

struct hui {
    int64_t pos;
    int64_t length;
};

std::pair<int64_t, int64_t> twoMaxes(const std::vector<hui> &v) {
    int64_t max1 = 0;
    int64_t pos1 = -1;

    int64_t max2 = 0;
    int64_t pos2 = -1;

    for (int64_t i = 0; i < v.size(); ++i) {
        if (v[i].length > max1) {
            max2 = max1;
            pos2 = pos1;

            max1 = v[i].length;
            pos1 = i;
        } else if (v[i].length > max2) {
            max2 = v[i].length;
            pos2 = i;
        }
    }

    return {max1, max2};
}

std::pair<int64_t, int64_t> twoMaxes1(const std::vector<int64_t> &v) {
    int64_t max1 = 0;
    int64_t pos1 = -1;

    int64_t max2 = 0;
    int64_t pos2 = -1;

    for (int64_t i = 0; i < v.size(); ++i) {
        if (v[i] > max1) {
            max2 = max1;
            pos2 = pos1;

            max1 = v[i];
            pos1 = i;
        } else if (v[i] > max2) {
            max2 = v[i];
            pos2 = i;
        }
    }

    return {max1, max2};
}

int64_t binSearch(const vector<hui> &v, int64_t pos) {
    int64_t l = -1;
    int64_t r = v.size();
    while (r - l != 1) {
        int64_t m = r + (l - r) / 2;
        if (v[m].pos < pos) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

int main() {
    fastio;

    int64_t t;
    cin >> t;
    while (t--) {
        int64_t n, m;
        cin >> n >> m;

        vector<vector<bool>> field(n, vector<bool>(m, true));
        for (int64_t i = 0; i < n; ++i) {
            string s;
            cin >> s;
            for (int64_t j = 0; j < m; ++j) {
                if (s[j] == '#') {
                    field[i][j] = false;
                }
            }
        }

        // nice dick (precalc)
        vector<vector<hui>> rows(n);
        vector<int64_t> rowsMax1(n);
        vector<int64_t> rowsMax2(n);
        vector<int64_t> rowsMaxes;
        for (int64_t i = 0; i < n; ++i) {
            int64_t begin = -1;
            for (int64_t j = 0; j < m; ++j) {
                if (begin == -1) {
                    if (field[i][j]) {
                        begin = j;
                    }
                } else {
                    if (!field[i][j]) {
                        rows[i].push_back({begin, j - begin});
                        begin = -1;
                    } else if (j == m - 1) {
                        rows[i].push_back({begin, j - begin + 1});
                    }
                }
            }
            auto maxes = twoMaxes(rows[i]);
            rowsMax1[i] = maxes.first;
            rowsMax2[i] = maxes.second;
            rowsMaxes.push_back(maxes.first);
            rowsMaxes.push_back(maxes.second);
        }

        vector<vector<hui>> cols(m);
        vector<int64_t> colsMax1(m);
        vector<int64_t> colsMax2(m);
        vector<int64_t> colsMaxes;
        for (int64_t j = 0; j < m; ++j) {
            int64_t begin = -1;
            for (int64_t i = 0; i < n; ++i) {
                if (begin == -1) {
                    if (field[i][j]) {
                        begin = i;
                    }
                } else {
                    if (!field[i][j]) {
                        cols[j].push_back({begin, i - begin});
                        begin = -1;
                    } else if (i == n - 1) {
                        cols[j].push_back({begin, i - begin + 1});
                    }
                }
            }
            auto maxes = twoMaxes(cols[j]);
            colsMax1[j] = maxes.first;
            colsMax2[j] = maxes.second;
            colsMaxes.push_back(maxes.first);
            colsMaxes.push_back(maxes.second);
        }

        if (n == 1 && m == 1 && field[0][0]) {
            cout << 1 << "\n";
            continue;
        }

        int64_t res = 0;

        auto maxes = twoMaxes1(rowsMaxes);
        res = max(res, maxes.first + maxes.second);

        maxes = twoMaxes1(colsMaxes);
        res = max(res, maxes.first + maxes.second);

        for (int64_t i = 0; i < n; ++i) {
            for (hui h : rows[i]) {
                for (int64_t j = h.pos; j < h.pos + h.length; ++j) {
                    int64_t crossPos = binSearch(cols[j], i);

                    if (crossPos == -1) {
                        res = max(res, h.length + colsMax1[j]);
                        continue;
                    }

                    hui crossedHui = cols[j][crossPos];
                    if (i < crossedHui.pos + crossedHui.length) {
                        // cross
                        ll h1 = i - crossedHui.pos;
                        ll h2 = crossedHui.pos + crossedHui.length - i - 1;
                        ll h3 = j - h.pos;
                        ll h4 = h.pos + h.length - j - 1;

                        ll minH = min(min(h1, h2), min(h3, h4));

                        res = max(res, h1 + h2 + h3 + h4 + 1 - minH);
                        if (crossedHui.length != colsMax1[j]) {
                            res = max(res, colsMax1[j]);
                        } else {
                            res = max(res, colsMax2[j]);
                        }

                    } else {
                        res = max(res, h.length + colsMax1[j]);
                    }
                }
            }
        }
        cout << res << "\n";
    }


    return 0;
}
