#include<iostream>
#include<string>
#include<vector>
#include<algorithm>
#include<limits>
#include<cmath>
#include<fstream>
#include<iomanip>
#include<ctime>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<stack>

using namespace std;

long long mod = 1e9 + 7;

long long gcd(long long a, long long b) {
	if (a < b){
		swap(a, b);
	}
	while (b != 0) {
		a %= b;
		swap(a, b);
	}
	return a;
}

long long bin_pow(long long a, long long b) {
	if (b == 0) {
		return 1;
	}
	if (b == 1) {
		return a % mod;
	}
	if (b % 2 == 0) {
		return (bin_pow((a * a) % mod, b / 2)) % mod;
	}
	return ((a % mod) * bin_pow(a, b - 1)) % mod;
}

vector<int> prefix_fun(string& s) {
	vector<int> p(s.size(), 0);
	for (int i = 1; i < s.size(); ++i) {
		int j = p[i - 1];
		while (j > 0 && s[j] != s[i]) j = p[j];
		if (s[i] == s[j]) ++j;
		p[i] = j;
	}
	return move(p);
}

template<typename Type>
class segmentTree{
public:
	segmentTree(const vector<Type>& vec): data(vec.size()*4) {
		for (int i = data.size() - 1; i >= 0; --i) {
		}
	}

	vector<Type> data;
};

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

void solve_b() {
	int n, m;
	cin >> n >> m;
	vector<vector<bool>> mat(n, vector<bool>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			char type;
			cin >> type;
			mat[i][j] = 0;
			if (type == '.') mat[i][j] = 1;
		}
	}
	vector<int> dp_left(m, 0);
	vector<int> max_left(n, 0);
	for (int j = 0; j < m; ++j) {
		for (int i = 0; i < n; ++i) {
			if (mat[i][j]) ++max_left[i];
			else max_left[i] = 0;
			dp_left[j] = max(dp_left[j], max_left[i]);
		}
	}
	for (int j = 0; j < m; ++j) {
		int maxv = 0;
		for (int i = 0; i < n; ++i) {
			if (mat[i][j]) ++maxv;
			else maxv = 0;
			dp_left[j] = max(dp_left[j], maxv);
		}
	}
	for (int j = 1; j < m; ++j) dp_left[j] = max(dp_left[j], dp_left[j - 1]);
	vector<int> dp_right(m, 0);
	vector<int> max_right(n, 0);
	for (int j = m - 1; j > -1; --j) {
		for (int i = 0; i < n; ++i) {
			if (mat[i][j]) ++max_right[i];
			else max_right[i] = 0;
			dp_right[j] = max(dp_right[j], max_right[i]);
		}
	}
	for (int j = m - 1; j > -1; --j) {
		int maxv = 0;
		for (int i = 0; i < n; ++i) {
			if (mat[i][j]) ++maxv;
			else maxv = 0;
			dp_right[j] = max(dp_right[j], maxv);
		}
	}
	for (int j = m - 2; j > -1; --j) dp_right[j] = max(dp_right[j], dp_right[j + 1]);
	vector<int> dp_up(n, 0);
	vector<int> max_up(m, 0);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (mat[i][j]) ++max_up[j];
			else max_up[j] = 0;
			dp_up[i] = max(dp_up[i], max_up[j]);
		}
	}
	for (int i = 0; i < n; ++i) {
		int maxv = 0;
		for (int j = 0; j < m; ++j) {
			if (mat[i][j]) ++maxv;
			else maxv = 0;
			dp_up[i] = max(dp_up[i], maxv);
		}
	}
	for (int i = 1; i < n; ++i) dp_up[i] = max(dp_up[i], dp_up[i - 1]);
	vector<int> dp_down(n, 0);
	vector<int> max_down(m, 0);
	for (int i = n - 1; i > -1; --i) {
		for (int j = 0; j < m; ++j) {
			if (mat[i][j]) ++max_down[j];
			else max_down[j] = 0;
			dp_down[i] = max(dp_down[i], max_down[j]);
		}
	}
	for (int i = n - 1; i > -1; --i) {
		int maxv = 0;
		for (int j = 0; j < m; ++j) {
			if (mat[i][j]) ++maxv;
			else maxv = 0;
			dp_down[i] = max(dp_down[i], maxv);
		}
	}
	for (int j = n - 2; j > -1; --j) dp_down[j] = max(dp_down[j], dp_down[j + 1]);

	int ans = max(dp_left[m - 1], dp_right[0]);
	for (int i = 1; i < m; ++i) {
		ans = max(ans, dp_left[i - 1] + dp_right[i]);
	}
	ans = max(ans, dp_up[n - 1]);
	for (int i = 1; i < n; ++i) {
		ans = max(ans, dp_up[i - 1] + dp_down[i]);
	}
	cout << ans << endl;
}

void solve_B() {
	int q;
	cin >> q;
	while (q--) {
		solve_b();
	}
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie();
	solve_B();
}
