#include<iostream>
#include<string>
#include<vector>
#include<algorithm>
#include<limits>
#include<cmath>
#include<fstream>
#include<iomanip>
#include<ctime>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<stack>
#include<tuple>

using namespace std;

long long mod = 998244353;

long long gcd(long long a, long long b) {
	if (a < b) {
		swap(a, b);
	}
	while (b != 0) {
		a %= b;
		swap(a, b);
	}
	return a;
}

long long bin_pow(long long a, long long b) {
	if (b == 0) {
		return 1;
	}
	if (b == 1) {
		return a % mod;
	}
	if (b % 2 == 0) {
		return (bin_pow((a * a) % mod, b / 2)) % mod;
	}
	return ((a % mod) * bin_pow(a, b - 1)) % mod;
}

vector<int> prefix_fun(string& s) {
	vector<int> p(s.size(), 0);
	for (int i = 1; i < s.size(); ++i) {
		int j = p[i - 1];
		while (j > 0 && s[j] != s[i]) j = p[j];
		if (s[i] == s[j]) ++j;
		p[i] = j;
	}
	return move(p);
}

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

double sith(int depth) {
	if (depth == 0) return 2;
	return tan(sith(depth - 1));
}

class node {
public:
	int l, r;
	node* left, * right;
	long long m;
	long long k;

	node(vector<long long>& s, int l_, int r_) {
		if (l_ == r_) {
			left = right = nullptr;
			l = r = l_;
			k = 0;
			m = s[l_];
		}
		else {
			left = new node(s, l_, (l_ + r_) / 2);
			right = new node(s, (l_ + r_) / 2 + 1, r_);
			l = l_;
			r = r_;
			k = 0;
			m = min(left->m, right->m);
		}
	}

	void push() {
		if (k == 0)
		{
			return;
		}
		m += k;
		if (left) {
			left->k += k;
		}
		if (right) {
			right->k += k;
		}
		k = 0;
	}

	void add(int l_, int r_, long long x) {
		push();
		if (l > r_ || r < l_) {
			return;
		}
		if (l >= l_ && r <= r_) {
			k += x;
			return;
		}
		if (left) {
			left->add(l_, r_, x);
		}
		if (right) {
			right->add(l_, r_, x);
		}
		m = min(left->m + left->k, right->m + right->k);
	}

	long long mex() {
		push();
		if (m != 0) {
			return r + 1;
		}
		if (!left) {
			return l;
		}
		if (left->m + left->k == 0) {
			return left->mex();
		}
		return right->mex();
	}

	long long count(int x) {
		push();
		if (l == x && r == x) {
			return m;
		}
		if (left && left->l <= x && left->r >= x) {
			return left->count(x);
		}
		return right->count(x);
	}

};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie();
	//for (int i = 0; i < 100; ++i) cout << sith(i) << ' ';

	int n;
	cin >> n;
	vector<long long> s(n);
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	multiset<long long> ms;
	node root(s, 0, n - 1);
	long long p = root.mex();
	long long ans = 0;
	while (p != 0) {
		ms.insert(p);
		ans += p;
		root.add(0, p - 1, -1);
		p = root.mex();
	}
	int q;
	cin >> q;
	cout << ans << '\n';
	for (int i = 0; i < q; ++i) {
		int x;
		long long y;
		cin >> x >> y;
		if (x == 1) {
			if (ms.find(y) != ms.end()) {
				ms.erase(ms.find(y));
				ans -= y;
				root.add(0, y, 1);
				p = root.mex();
				ms.insert(p);
				ans += p;
				root.add(0, p - 1, -1);
			}
			else {
				root.add(y, y, 1);
				p = root.mex();
				if (p != 0) {
					ans += p;
					ms.insert(p);
					root.add(0, p - 1, -1);
				}
			}
		}
		else {
			if (root.count(y) != 0) {
				root.add(y, y, -1);
			}
			else {
				int e = *upper_bound(ms.begin(), ms.end(), y);
				root.add(y + 1, e - 1, +1);
				ms.erase(ms.find(e));
				ans -= e;
				ms.insert(y);
				ans += y;
			}
		}
		cout << ans << '\n';
	}
}