#include <bits/stdc++.h>
// B started 13:55

using namespace std;

bool is_free(vector<string> &p, int i, int j) {
    if (0 <= i && i < p.size() && 0 <= j && j < p[0].size()) {
        return p[i][j] == '.';
    } else {
        return false;
    }
}

vector<vector<int>> build_dp(vector<string> &p) {
    int n = p.size();
    int m = p[0].size();

    vector<vector<int>> dp(n, vector<int>(m));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if(p[i][j] == '#'){
                continue;
            }


            // gorizontal
            if (!is_free(p, i, j - 1)) {
                for (int k = j; k < m && p[i][k] == '.'; k++) {
                    dp[i][k] = max(dp[i][k], k - j + 1);
                }
            }

            // vertical
            if (!is_free(p, i - 1, j)) {
                for (int k = i; k < n && p[k][j] == '.'; k++) {
                    dp[k][j] = max(dp[k][j], k - i + 1);
                }
            }
        }
    }

    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            if(i + 1 < n){
                dp[i + 1][j] = max(dp[i + 1][j], dp[i][j]);
            }
            if(j + 1 < m){
                dp[i][j + 1] = max(dp[i][j + 1], dp[i][j]);
            }
        }
    }

    return dp;
}

int solve(vector<string>& p){
    int n = p.size();
    int m = p[0].size();

    auto dp = build_dp(p);

    auto inv_p = p;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            inv_p[i][j] = p[n - i - 1][m - j - 1];
        }
    }

    auto inv_dp = build_dp(inv_p);

    auto dp2 = inv_dp;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            dp2[i][j] = inv_dp[n - i - 1][m - j - 1];

            //cout << dp2[i][j] << ' ';
        }
        //cout << endl;
    }

    int ans = 0;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if(p[i][j] == '#'){
                continue;
            }

            // gorizontal
            if (!is_free(p, i, j - 1)) {
                for (int k = j; k < m && p[i][k] == '.'; k++) {
                    int cur = 0;
                    if(j > 0) {
                        cur = max(cur, dp[n - 1][j - 1]);
                    }
                    if(i > 0){
                        cur = max(cur, dp[i - 1][m - 1]);
                    }

                    if(k + 1 < m){
                        cur = max(cur, dp2[0][k + 1]);
                    }

                    if(i + 1 < n) {
                        cur = max(cur, dp2[i + 1][0]);
                    }

                    ans = max(ans, cur + k - j + 1);
                }
            }

            // vertical
            if (!is_free(p, i - 1, j)) {
                for (int k = i; k < n && p[k][j] == '.'; k++) {
                    int cur = 0;

                    if(i > 0){
                        cur = max(cur, dp[i - 1][m - 1]);
                    }

                    if(j > 0){
                        cur = max(cur, dp[n - 1][j - 1]);
                    }

                    if(k + 1 < n){
                        cur = max(cur, dp2[k + 1][0]);
                    }

                    if(j + 1 < m){
                        cur = max(cur, dp2[0][j + 1]);
                    }

                    ans = max(ans, cur + k - i + 1);
                }
            }
        }
    }

    return ans;
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<string> p(n);
        for (int i = 0; i < n; i++) {
            cin >> p[i];
        }

        cout << solve(p) << endl;
    }
}
