import java.io.BufferedWriter

fun main() = withFastOut(readInt()) {
    val (n, m) = readInts()
    val d = Array(n) { read().map { it == '.' } }
    data class Interval(var s: Int, val start: Int, var end: Int)
    val vertical = Array(m) { listOf<Interval>() }
    val horizontal = Array(n) { listOf<Interval>() }
    for (j in 0 until m) {
        val res = mutableListOf<Interval>()
        var cur = Interval(0, 0, 0)
        for (i in 0 until n) {
            if (d[i][j]) {
                cur.s++
                cur.end++
            } else {
                if (cur.s > 0 || res.isEmpty()) res += cur
                cur = Interval(0, i + 1, i + 1)
            }
        }
        if (res.lastOrNull() != cur) res += cur
        vertical[j] = res.sortedByDescending { it.s }.take(2)
    }
    for (i in 0 until n) {
        val res = mutableListOf<Interval>()
        var cur = Interval(0, 0, 0)
        for (j in 0 until m) {
            if (d[i][j]) {
                cur.s++
                cur.end++
            } else {
                if (cur.s > 0 || res.isEmpty()) res += cur
                cur = Interval(0, j + 1, j + 1)
            }
        }
        if (res.lastOrNull() != cur) res += cur
        horizontal[i] = res.sortedByDescending { it.s }.take(2)
    }

    var ans = 0
    for (i in 0 until n) {
        for (j in 0 until m) {
            val vert = vertical[j][0]
            val horiz = horizontal[i][0]
            val tmp =
                if (i in vert.start until vert.end && j in horiz.start until horiz.end) {
                    fun grep(i: Int, interval: Interval, j: Int, other: List<Interval>): Int {
                        val a = mutableListOf<Int>()
                        a += other[0].end - i - 1
                        a += i - other[0].start
                        other.getOrNull(1)?.let {
                            a += it.s
                        }
                        return a.maxOf { it } + interval.s
                    }
                    maxOf(grep(i, horiz, j, vertical[j]), grep(j, vert, i, horizontal[i]))
                } else {
                    vert.s + horiz.s
                }
            ans = maxOf(ans, tmp)
        }
    }
    ans = maxOf(ans, horizontal.sortedByDescending { it[0].s }.take(2).sumOf { it[0].s })
    ans = maxOf(ans, horizontal.maxOf { it.take(2).sumOf { it.s } })
    ans = maxOf(ans, vertical.sortedByDescending { it[0].s }.take(2).sumOf { it[0].s })
    ans = maxOf(ans, vertical.maxOf { it.take(2).sumOf { it.s } })

    println(ans)
}

val reader = System.`in`.bufferedReader()
//val tokenizer = StreamTokenizer(reader)

fun readInt() = reader.readLine().toInt()
fun read(): String = reader.readLine()
fun readInts() = reader.readLine().split(" ").map { it.toInt() }

inline fun withFastOut(n: Int = 1, fn: BufferedWriter.() -> Unit) {
    repeat(n) { fn(System.out.bufferedWriter()) }
}