#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct hole
{
    long long len = 0, line, beg, en;
};

vector<vector<char> > v;
vector<hole> vert, horiz;

bool cmp(hole h1, hole h2)
{
    return h1.len > h2.len;
}

long long hor_2()
{
    if (horiz.size() == 0)
    {
        return 0;
    }
    if (horiz.size() == 1)
    {
        return horiz[0].len;
    }
    return horiz[0].len + horiz[1].len;
}

long long vert_2()
{
    if (vert.size() == 0)
    {
        return 0;
    }
    if (vert.size() == 1)
    {
        return vert[0].len;
    }
    return vert[0].len + vert[1].len;
}

long long hor_vert()
{
    long long mx = -1;
    for (int i = 0; i < horiz.size(); i++)
    {
        for (int j = 0; j < vert.size(); j++)
        {
            if (horiz[i].line > vert[j].en || horiz[i].line < vert[j].beg || vert[j].line < horiz[i].beg || vert[j].line > horiz[i].en)
            {
                mx = max(mx, horiz[i].len + vert[j].len);
            }
            else
            {
                mx = max(mx, horiz[i].len + max(horiz[i].line - vert[j].beg, vert[j].en - horiz[i].line));
                mx = max(mx, vert[j].len + max(vert[j].line - horiz[i].beg, horiz[i].en - vert[j].line));
            }
        }
    }
    return mx;
}

int main()
{
    long long test, n, m;
    cin >> test;
    for (int k = 0; k < test; k++)
    {
        cin >> n >> m;
        v.resize(n, vector<char> (m));
        vert.resize(0);
        horiz.resize(0);
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                cin >> v[i][j];
            }
        }
        hole h;
        bool flag = false;
        for (int i = 0; i < n; i++)
        {
            flag = false;
            for (int j = 0; j < m; j++)
            {
                h.line = i;
                if (v[i][j] == '.')
                {
                    if (j == 0 || v[i][j - 1] == '#')
                    {
                        h.beg = j;
                    }
                    flag = true;
                }
                else if (flag)
                {
                    h.en = j - 1;
                    h.len = h.en - h.beg + 1;
                    horiz.push_back(h);
                    flag = false;
                }
            }
            if (v[i][m - 1] != '#')
            {
                h.en = m - 1;
                h.len = h.en - h.beg + 1;
                horiz.push_back(h);
            }
        }
        flag = false;
        for (int j = 0; j < m; j++)
        {
            flag = false;
            for (int i = 0; i < n; i++)
            {
                h.line = j;
                if (v[i][j] == '.')
                {
                    if (i == 0 || v[i - 1][j] == '#')
                    {
                        h.beg = i;
                    }
                    flag = true;
                }
                else if (flag)
                {
                    h.en = i - 1;
                    h.len = h.en - h.beg + 1;
                    vert.push_back(h);
                    flag = false;
                }
            }
            if (v[n - 1][j] != '#')
            {
                h.en = n - 1;
                h.len = h.en - h.beg + 1;
                vert.push_back(h);
            }
        }

        /*for (int i = 0; i < horiz.size(); i++)
        {
            cout << horiz[i].line << ' ' << horiz[i].beg << ' ' << horiz[i].en << endl;
        }

        cout << "*************" << endl;

        for (int i = 0; i < vert.size(); i++)
        {
            cout << vert[i].line << ' ' << vert[i].beg << ' ' << vert[i].en << endl;
        }*/

        sort(horiz.begin(), horiz.end(), cmp);
        sort(vert.begin(), vert.end(), cmp);
        cout << max(hor_2(), max(vert_2(), hor_vert())) << endl;
    }
}

/*

5
2 2
..
..
4 5
###.#
#....
.##.#
#.#.#
2 1
.
.
2 3
###
#.#
5 4
##.#
..#.
#.#.
....
#.##

*/
