#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct hole {
    long long len = 0, line{}, beg{}, en{};

    void db() {
        cout << line << " " << beg << "-" << en;
    }
};

typedef long long ll;

bool cmp(hole h1, hole h2) {
    return h1.len > h2.len;
}

bool cmpbye(hole h1, hole h2) {
    return h1.en < h2.len;
}

bool cmpbyb(hole h1, hole h2) {
    return h1.beg > h2.beg;
}

long long int hor_2(const vector<struct hole> &horiz) {
    if (horiz.empty()) {
        return 0;
    }
    if (horiz.size() == 1) {
        return horiz[0].len;
    }
    return horiz[0].len + horiz[1].len;
}

long long int vert_2(const vector<struct hole> &vert) {
    if (vert.empty()) {
        return 0;
    }
    if (vert.size() == 1) {
        return vert[0].len;
    }
    return vert[0].len + vert[1].len;
}

long long int hor_vert(const vector<struct hole> &horiz, const vector<struct hole> &vert,
                       const vector<vector<vector<struct hole>>> &hh) {
    long long mx = 0;
    for (int i = 0; i < hh.size(); ++i) {
        for (int j = 0; j < hh[i].size(); ++j) {
            const auto &c = hh[i][j];
            if (c.size() != 2) { continue; }
            hole f = c[0];
            hole s = c[1];
            long long m = max(
                    f.len + max(f.line - s.beg, s.en - f.line),
                    s.len + max(s.line - f.beg, f.en - s.line)
            );
            mx = max(mx, m);
        }
    }
    return mx;
}


void finish_v(vector<hole> &vert, int i, hole &h, bool &flag, vector<vector<vector<struct hole>>> &hh) {
    h.en = i;
    h.len = h.en - h.beg + 1;
    vert.push_back(h);
    for (int ii = h.beg; ii <= h.en; ++ii) {
        hh[ii][h.line].push_back(h);
    }
    flag = false;
}

void finish_h(vector<hole> &horiz, int j, hole &h, bool &flag, vector<vector<vector<struct hole>>> &hh,
              vector<long long int> &hlis, vector<long long int> &hbe, vector<long long int> &hbb) {
    h.en = j;
    h.len = h.en - h.beg + 1;
    horiz.push_back(h);
    for (ll jj = h.beg; jj <= h.en; ++jj) {
        hh[h.line][jj].push_back(h);
    }
    hlis[h.line] = max(hlis[h.line], h.len);
    hbe[h.en] = max(hbe[h.en], h.len);
    hbb[h.beg] = max(hbe[h.beg], h.len);
    flag = false;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<vector<hole>>> hh(n, vector<vector<hole>>(m));
    vector<long long> hop(n), hos(n);
    vector<long long> hbe(m), hbb(m);
    vector<long long> hlis(n);
    vector<vector<char> > v(n, vector<char>(m));
    vector<hole> vert, horiz;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> v[i][j];
        }
    }
    hole h;
    bool flag;
    for (int i = 0; i < n; i++) {
        flag = false;
        for (int j = 0; j < m; j++) {
            h.line = i;
            if (v[i][j] == '.') {
                if (j == 0 || v[i][j - 1] == '#') {
                    h.beg = j;
                }
                flag = true;
            } else if (flag) {
                finish_h(horiz, j - 1, h, flag, hh, hlis, hbe, hbb);
            }
        }
        if (v[i][m - 1] != '#') {
            finish_h(horiz, m - 1, h, flag, hh, hlis, hbe, hbb);
        }
    }
    for (int j = 0; j < m; j++) {
        flag = false;
        for (int i = 0; i < n; i++) {
            h.line = j;
            if (v[i][j] == '.') {
                if (i == 0 || v[i - 1][j] == '#') {
                    h.beg = i;
                }
                flag = true;
            } else if (flag) {
                finish_v(vert, i - 1, h, flag, hh);
            }
        }
        if (v[n - 1][j] != '#') {
            finish_v(vert, n - 1, h, flag, hh);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (i > 0) { hop[i] = hop[i - 1]; }
        hop[i] = max(hop[i], hlis[i]);
    }
    for (int i = n - 1; i >= 0; --i) {
        if (i < n - 1) { hos[i] = hos[i + 1]; }
        hos[i] = max(hos[i], hlis[i]);
    }
    for (int j = 1; j < m; ++j) {
        hbe[j] = max(hbe[j], hbe[j - 1]);
    }
    for (int j = m - 2; j > 0; --j) {
        hbb[j] = max(hbb[j], hbb[j + 1]);
    }

    sort(horiz.begin(), horiz.end(), cmp);
    sort(vert.begin(), vert.end(), cmp);
    ll ans = max(hor_2(horiz), max(vert_2(vert), hor_vert(horiz, vert, hh)));
    for (const auto &h: vert) {
        if (h.line > 0 && hbe[h.line - 1] > 0) {
            ans = max(ans, h.len + hbe[h.line - 1]);
        }
        if (h.line < m - 1 && hbb[h.line + 1] > 0) {
            ans = max(ans, h.len + hbb[h.line + 1]);
        }
        if (h.beg > 0 && hop[h.beg - 1] > 0) {
            ans = max(ans, h.len + hop[h.beg - 1]);
        }
        if (h.en < n - 1 && hos[h.en + 1] > 0) {
            ans = max(ans, h.len + hos[h.en + 1]);
        }
    }
//    sort(horiz.begin(), horiz.end(), cmpbye);

//    if (!horiz.empty()) {
//        if ()
//        ans = max(ans, horiz[0].len + )
//    }

    cout << ans << endl;
}

int main() {
    long long test;
    cin >> test;
    for (int k = 0; k < test; k++) {
        solve();
    }
}


/*

5
2 2
..
..
4 5
###.#
#....
.##.#
#.#.#
2 1
.
.
2 3
###
#.#
5 4
##.#
..#.
#.#.
....
#.##

*/
