#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;

struct dice
{
    long long bottom = -1, top = - 1, frontt = -1, backk = -1, left = -1, right = -1;
    char st_bottom = 'd', st_top = 't', st_frontt = 'f', st_backk = 'b', st_left = 'l', st_right = 'r';
};

map<char, char> mright = {{'d', 'l'}, {'l', 't'}, {'t', 'r'}, {'r', 'd'}, {'f', 'f'}, {'b', 'b'}};
map<char, char> mdown = {{'d', 'b'}, {'b', 't'}, {'t', 'f'}, {'f', 'd'}, {'l', 'l'}, {'r', 'r'}};

dice to_right(dice d)
{
    dice d_new;

    d_new.backk = d.backk;
    d_new.frontt = d.frontt;
    d_new.left = d.bottom;
    d_new.right = d.top;
    d_new.bottom = d.right;
    d_new.top = d.left;

    return d_new;
}

dice to_down(dice d)
{
    dice d_new;

    d_new.left = d.left;
    d_new.right = d.right;
    d_new.bottom = d.frontt;
    d_new.frontt = d.top;
    d_new.top = d.backk;
    d_new.backk = d.bottom;

    return d_new;
}

int n;
bool flag;
dice ans;


vector<char> path;

void dfs(dice d, int i, int j, vector<vector<long long int>>& color)
{
    if (d.bottom != color[i][j])
    {
        if (d.bottom == -1)
        {
            d.bottom = color[i][j];
        }
        else
        {
            return;
        }
    }
    if (i == n - 1 && j == n - 1)
    {
        flag = true;
        ans = d;
        return;
    }
    dice d_new = to_right(d);
    if (j + 1 < n)
    {
        dfs(d_new, i, j + 1, color);
        if (flag)
        {
            path.push_back('r');
            return;
        }
    }
    d_new = to_down(d);
    if (i + 1 < n)
    {
        dfs(d_new, i + 1, j, color);
        if (flag)
        {
            path.push_back('d');
            return;
        }
    }
}

long long rand_color;

long long p(char c)
{
    if (c == 'l')
    {
        return (ans.left == -1 ? rand_color : ans.left);
    }
    if (c == 'r')
    {
        return (ans.right == -1 ? rand_color : ans.right);
    }
    if (c == 'd')
    {
        return (ans.bottom == -1 ? rand_color : ans.bottom);
    }
    if (c == 't')
    {
        return (ans.top == -1 ? rand_color : ans.top);
    }
    if (c == 'f')
    {
        return (ans.frontt == -1 ? rand_color : ans.frontt);
    }
    if (c == 'b')
    {
        return (ans.backk == -1 ? rand_color : ans.backk);
    }
}

int main()
{
    int test;
    cin >> test;
    for (int k = 0; k < test; k++)
    {
        flag = false;
        cin >> n;
        vector<vector<long long> > color(n, vector<long long> (n));
        path.clear();
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < n; j++)
            {
                cin >> color[i][j];
            }
        }
        rand_color = color[0][0];
        dice d;
        d.bottom = color[0][0];
        dice d_new;
        d_new = to_right(d);
        dfs(d_new, 0, 1, color);
        if (flag)
        {
            path.push_back('r');
        }
        else
        {
            d_new = to_down(d);
            dfs(d_new, 1, 0, color);
            if (flag)
            {
                path.push_back('d');
            }
        }
        if (flag)
        {
            int x = 0, y = 0;
            reverse(path.begin(), path.end());

            for (int i = 0; i < path.size(); i++)
            {
                if (path[i] == 'r')
                {
                    ans.st_backk = mright[ans.st_backk];
                    ans.st_bottom = mright[ans.st_bottom];
                    ans.st_frontt = mright[ans.st_frontt];
                    ans.st_top = mright[ans.st_top];
                    ans.st_left = mright[ans.st_left];
                    ans.st_right = mright[ans.st_right];
                    y++;
                }
                else
                {
                    ans.st_backk = mdown[ans.st_backk];
                    ans.st_bottom = mdown[ans.st_bottom];
                    ans.st_frontt = mdown[ans.st_frontt];
                    ans.st_top = mdown[ans.st_top];
                    ans.st_left = mdown[ans.st_left];
                    ans.st_right = mdown[ans.st_right];
                    x++;
                }
                //ans.bottom = color[x][y];
            }
            cout << "Yes" << endl;
            cout << p(ans.st_bottom) << ' ' << p(ans.st_left) << ' ' << p(ans.st_backk) << ' ' << p(ans.st_frontt) << ' ';
            cout << p(ans.st_right) << ' ' << p(ans.st_top) << endl;
        }
        else
        {
            cout << "No" << endl;
        }
    }
}
