#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <cmath>

using namespace std;

void cancel(vector<vector<char>>& v, int starti, int startj, int finishi, int finishj)
{
    if(starti == finishi)
    {
        for(int j = startj; j < finishj; j++)
        {
            v[starti][j] = '.';
        }
    }else{
        for(int i = starti; i < finishi; i++)
        {
            v[i][startj] = '.';
        }
    }
}

long long find_max(vector<vector<char>>& v)
{
    long long ans = 0, flag = 0;
    for(int i = 1; i < v.size(); i++)
    {
        flag = 0;
        for(int j = 1; j < v[0].size(); j++)
        {
            if(v[i][j] == '#')
            {
                ans = max(ans, flag);
                flag = 0;
            }else{
                flag++;
            }
        }
    }
    flag = 0;
    for(int j = 1; j < v[0].size(); j++)
    {
        flag = 0;
        for(int i = 1; i < v.size(); i++)
        {
            if(v[i][j] == '#')
            {
                ans = max(ans, flag);
                flag = 0;
            }else{
                flag++;
            }
        }
    }
    return ans;
}

void sol()
{
    long long n, m;
    cin >> n >> m;

    vector<vector<char>>v;
    v.resize(n + 2, vector<char>(m + 2, '#'));
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            cin >> v[i][j];
        }
    }
    bool started = 0;
    int start, finish;
    long long ans = 0;
    long long cur = 0;;
    for(int i = 1; i < v.size(); i++)
    {
        started = 0;
        cur = 0;
        for(int j = 1; j < v[0].size(); j++)
        {
            if(v[i][j] == '.')
            {
                cur++;
                if(!started)
                {
                    start = j;
                }
                v[i][j] = '#';
                started = 1;
            }else{
                if(started)
                {
                    finish = j;
                    //cout << cur << " " << find_max(v) << endl;
                    cur += find_max(v);
                    ans = max(cur, ans);
                    cur = 0;
                    cancel(v, i, start, i, finish);
                    started = 0;

                }
            }
        }

    }

    for(int j = 1; j < v[0].size(); j++)
    {
        started = 0;
        cur = 0;
        for(int i = 1; i < v.size(); i++)
        {
            if(v[i][j] == '.')
            {
                cur++;
                if(!started)
                {
                    start = i;
                }
                v[i][j] = '#';
                started = 1;
            }else{
                if(started)
                {
                    finish = i;
                    cur += find_max(v);
                    ans = max(cur, ans);
                    cur = 0;
                    cancel(v, start, j, finish, j);
                    started = 0;
                }
            }
        }

    }
    cout << ans << "\n";

}

int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    long long t;
    cin >> t;
    while(t--)
    {
        sol();
    }
}


