#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <cmath>

using namespace std;

void cancel(vector<vector<char>>& v, int starti, int startj, int finishi, int finishj, char c)
{
    if(starti == finishi)
    {
        for(int j = startj; j < finishj; j++)
        {
            v[starti][j] = c;
        }
    }else{
        for(int i = starti; i < finishi; i++)
        {
            v[i][startj] = c;
        }
    }
}

long long find_max(vector<vector<char>>& v)
{
    long long ans = 0, flag = 0;
    for(int i = 1; i < v.size(); i++)
    {
        flag = 0;
        for(int j = 1; j < v[0].size(); j++)
        {
            if(v[i][j] == '#')
            {
                ans = max(ans, flag);
                flag = 0;
            }else{
                flag++;
            }
        }
    }
    flag = 0;
    for(int j = 1; j < v[0].size(); j++)
    {
        flag = 0;
        for(int i = 1; i < v.size(); i++)
        {
            if(v[i][j] == '#')
            {
                ans = max(ans, flag);
                flag = 0;
            }else{
                flag++;
            }
        }
    }
    return ans;
}

void sol()
{
    long long n, m;
    cin >> n >> m ;
    vector< pair<long long, pair<pair<long long, long long>, pair<long long, long long>>> >top;
    vector<vector<char>>v;
    v.resize(n + 2, vector<char>(m + 2, '#'));
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            cin >> v[i][j];
        }
    }
    bool started = 0;
    int start, finish;
    long long ans = 0;
    long long cur = 0;;
    for(int i = 1; i < v.size(); i++)
    {
        started = 0;
        cur = 0;
        for(int j = 1; j < v[0].size(); j++)
        {
            if(v[i][j] == '.')
            {
                cur++;
                if(!started)
                {
                    start = j;
                }
                started = 1;
            }else{
                if(started)
                {
                    finish = j;
                    top.push_back(make_pair(cur, make_pair(make_pair(i, start), make_pair(i, finish))));
                    cur = 0;
                    started = 0;

                }
            }
        }

    }

    for(int j = 1; j < v[0].size(); j++)
    {
        started = 0;
        cur = 0;
        for(int i = 1; i < v.size(); i++)
        {
            if(v[i][j] == '.')
            {
                cur++;
                if(!started)
                {
                    start = i;
                }
                started = 1;
            }else{
                if(started)
                {
                    finish = i;
                    top.push_back(make_pair(cur, make_pair(make_pair(start, j), make_pair(finish, j))));
                    cur = 0;
                    started = 0;
                }
            }
        }

    }

    sort(top.begin(), top.end());
    //cout << top.size() << "\n";
    int fl = 0;
    for(int i = top.size() - 1; i > -1; i--)
    {
        cancel(v, top[i].second.first.first, top[i].second.first.second, top[i].second.second.first, top[i].second.second.second, '#');
        //cout << top[i].first << " " << find_max(v) << endl;
        ans = max(ans, top[i].first + find_max(v));
        cancel(v, top[i].second.first.first, top[i].second.first.second, top[i].second.second.first, top[i].second.second.second, '.');
        fl++;
        if(fl >= 10)
            break;
    }
    cout << ans << "\n";

}

int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    long long t;
    cin >> t;
    while(t--)
    {
        sol();
    }
}



