#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Wall {
    int len;
    bool horny;
    int x1, x2;
    int y1, y2;
};

vector <Wall*> walls;

bool cmp(Wall *a, Wall *b) {
    return a->len > b->len;
}

int intersect(Wall *a, Wall *b) {
    if (a->horny && b->horny || !(a->horny || b->horny))
        return a->len + b->len;
    else {
        if (a->horny)
            swap(a, b);

        if (a->x1 < b->x1 || a->x1 > b->x2) return a->len + b->len;
        if (b->y1 < a->y1 || b->y1 > a->y2) return a->len + b->len;

        int horLen = max(a->x1 - b->x1, b->x2 - a->x1) + a->len;
        int verLen = max(b->y1 - a->y1, a->y2 - b->y1) + b->len;
        return max(horLen, verLen);
    }
}

void addHorWall(int y, int x1, int x2) {
    Wall *wall = new Wall();
    wall->y1 = y;
    wall->x1 = x1;
    wall->x2 = x2;
    wall->horny = true;
    wall->len = (x2 - x1 + 1);
    walls.push_back(wall);
}

void addVerWall(int x, int y1, int y2) {
    Wall *wall = new Wall();
    wall->x1 = x;
    wall->y1 = y1;
    wall->y2 = y2;
    wall->horny = false;
    wall->len = (y2 - y1 + 1);
    walls.push_back(wall);
}

int main() {
    int tests;
    cin >> tests;
    while (tests--) {
        walls.clear();
        int n, m;
        cin >> n >> m;
        int **matrix = new int*[n];
        int **verdp = new int*[n];
        int **hordp = new int*[n];
        for (int i = 0; i < n; i++) {
            matrix[i] = new int[m];
            verdp[i] = new int[m];
            hordp[i] = new int[m];
            for (int j = 0; j < m; j++) {
                verdp[i][j] = 0;
                hordp[i][j] = 0;
            }

            for (int j = 0; j < m; j++) {
                char c;
                cin >> c;
                matrix[i][j] = (c == '.');
                if (j == 0)
                    hordp[i][j] = matrix[i][j];
                else
                    hordp[i][j] = (hordp[i][j - 1] + matrix[i][j]) * matrix[i][j];
                if (i == 0)
                    verdp[i][j] = matrix[i][j];
                else
                    verdp[i][j] = (verdp[i - 1][j] + matrix[i][j]) * matrix[i][j];
            }
        }

        for (int i = n-2; i >= 0; i--) {
            for (int j = m-2; j >= 0; j--) {
                if (matrix[i][j + 1])
                    hordp[i][j] = hordp[i][j + 1] * matrix[i][j];
                if (matrix[i + 1][j])
                    verdp[i][j] = verdp[i + 1][j] * matrix[i][j];
            }
        }

//        for (int i = 0; i < n; i++) {
//            for (int j = 0; j < m; j++)
//                cout << hordp[i][j] << " ";
//            cout << "     ";
//            for (int j = 0; j < m; j++)
//                cout << verdp[i][j] << " ";
//            cout << endl;
//        }

        for (int i = 0; i < n; i++) {
            bool hasWall = false;
            for (int j = 0; j < m; j++) {
                if (hordp[i][j] != 0 && !hasWall) {
                    int x1 = j, x2 = x1;
                    while (x2 < m && hordp[i][x2] != 0) x2++;
                    addHorWall(i, x1, x2 - 1);
                    hasWall = true;
                }
                if (hordp[i][j] == 0) hasWall = false;
            }
        }

        for (int j = 0; j < m; j++) {
            bool hasWall = false;
            for (int i = 0; i < n; i++) {
                if (verdp[i][j] != 0 && !hasWall) {
                    int y1 = i, y2 = y1;
                    while (y2 < n && verdp[y2][j] != 0) y2++;
                    addVerWall(j, y1, y2 - 1);
                    hasWall = true;
                }
                if (verdp[i][j] == 0) hasWall = false;
            }
        }

        sort(walls.begin(), walls.end(), cmp);

        int maxInt = 0;
        for (int i = 0; i < min(100, int(walls.size() - 1)); i++) {
            for (int j = i + 1; j < walls.size(); j++) {
                maxInt = max(maxInt, intersect(walls[i], walls[j]));
            }
        }
        cout << maxInt << endl;
    }
}
/*
###.#
#....
.##.#
#.#.#


 */