#include <iostream>
#include <algorithm>
#include <set>
#include <vector>

using namespace std;

int n;
int cnt = 0;

struct Config {
    int *a;
    long long hash;
    Config(int n) {
        a = new int[n];
    }
    long long cntHash() {
        int mult = 37;
        long long p = 1;
        int mod = 1e9 + 7;
        long long sum = 0;
        for (int i = 0; i < n; i++) {
            sum += a[i] * p;
            sum %= mod;
            p = (p * mult) % mod;
        }
        hash = sum;
    }
};
Config *final;
vector <pair<int, Config*> > path;

bool eq(Config *a, Config *b) {
    return a->hash == b->hash;
}

Config *copy(Config *a) {
    auto *ret = new Config(n);
    for (int i = 0; i < n; i++) {
        ret->a[i] = a->a[i];
    }
    return ret;
}

bool existsInPath(Config *conf) {
    for (auto i : path) {
        if (i.second->hash == conf->hash)
            return true;
    }
    return false;
}

int calc(Config *conf, int depth) {
    Config *next = copy(conf);

    for (int i = 0; i < n - 1; i++) {
        swap(next->a[i], next->a[i + 1]);
        next->cntHash();

        int razn = abs(next->a[i] - next->a[i + 1]);
        if (razn <= 1 || existsInPath(next)) {
            swap(next->a[i], next->a[i + 1]);
            continue;
        }
        path.push_back({i, next});
        cnt++;
        if (cnt > 20000) return -1;

        if (eq(next, final)) return depth;

        int result = calc(next, depth + 1);
        if (result != -1)
            return result;
        swap(next->a[i], next->a[i + 1]);
        next->cntHash(); // delete
        path.pop_back();
    }
    return -1;
}

int main() {
    cin >> n;
    auto* init = new Config(n);
    for (int i = 0; i < n; i++)
        cin >> init->a[i];
    init->cntHash();

    final = new Config(n);
    for (int i = 0; i < n; i++)
        cin >> final->a[i];
    final->cntHash();

    int result = calc(init, 1);
    cout << result << endl;
    for (int i = 0; i < path.size(); i++) {
        cout << path[i].first + 1 << " ";
    }
    cout << endl;
}
